#ifndef FUNCS_H         /* reinclusion protection */
#include <stdio.h>      /* for sprintf(), stderr, ... */

/* $HeadURL: https://svn.pasta.freemyip.com/main/ade/tags/3.0.1/arc/funcs.h $ $LastChangedRevision: 10405 $' */

/*
 *  Macros
 */

#define FUNCS_H         /* reinclusion protection */
#define TRUE  (0 == 0)
#define FALSE (0 != 0)
#define MSGFUNCS_ENABLED_FLAG TRUE

#if MSGFUNCS_ENABLED_FLAG
#define errormsg(fmt, ...) real_errormsg(__func__, fmt, ##__VA_ARGS__)
#define warningmsg(fmt, ...) real_warningmsg(__func__, fmt, ##__VA_ARGS__)
#define infomsg(fmt, ...) real_infomsg(__func__, fmt, ##__VA_ARGS__)
#define debugmsg(level, fmt, ...) real_debugmsg(__func__, level, fmt, ##__VA_ARGS__)
#else
#define errormsg(fmt, ...) 
#define warningmsg(fmt, ...)
#define infomsg(fmt, ...)
#define debugmsg(level, fmt, ...)
#endif

/*
 *  Forward declarations
 */

extern void real_errormsg(const char *, char *, ...);
extern void real_warningmsg(const char *, char *, ...);
extern void real_infomsg(const char *, char *, ...);
extern void real_debugmsg(const char *, unsigned int, char *, ...);

extern unsigned int verboselevel;

#endif                  /* reinclusion protection */
