#!/bin/bash
#  $HeadURL: https://svn.pasta.freemyip.com/main/ade/tags/3.0.1/share/tests/bin/ADESTDTEST300_shell_scripts_dont_write_to_lineno.sh $ $LastChangedRevision: 10631 $
PROGNAME=${0##*/}
SANDPIT=$(pwd)
. $(ade-config ade_share_prefix)/include/adetestsupport.sh

##############################################################################
#
#  LOAD TEST-SPECIFIC CONFIGURATION FILE
#
##############################################################################

[ "X$ADETEST_MODROOT" != X ] || adetestsupport_error "'ADETEST_MODROOT' not defined"
[ -r "$ADETEST_MODROOT/tests/in/$PROGNAME" ] || adetestsupport_error "can't read $ADETEST_MODROOT/tests/in/$PROGNAME"
. "$ADETEST_MODROOT/tests/in/$PROGNAME" || adetestsupport_error "problem sourcing $ADETEST_MODROOT/tests/in/$PROGNAME"
[ "X$PROGRAMS" != X ] || adetestsupport_error "'PROGRAMS' not defined"

##############################################################################
#
#  START OF TESTS
#
##############################################################################

echo "$PROGNAME: test started"

echo "searching for LINENO ...."
for PROGRAM in $PROGRAMS; do
    adetestsupport_invert_rc --quiet "grep -l LINENO $(type -p $PROGRAM)"
done

echo "searching for typeset or typset (misspelling) ...."
for PROGRAM in $PROGRAMS; do
    adetestsupport_invert_rc --quiet "egrep -l 'type?set' $(type -p $PROGRAM)"
done

echo "searching for UID or GID ...."
for PROGRAM in $PROGRAMS; do
    adetestsupport_invert_rc --quiet "egrep -wl 'UID|GID' $(type -p $PROGRAM)"
done

echo "searching for calls to 'ade_tmp_register -l ...' ..."
for PROGRAM in $PROGRAMS; do
    adetestsupport_invert_rc --quiet "egrep -wl 'ade_tmp_register -l' $(type -p $PROGRAM)"
done

echo "searching for assignments to FUNCNAME ..."
for PROGRAM in $PROGRAMS; do
    adetestsupport_invert_rc --quiet "egrep -wl 'FUNCNAME=' $(type -p $PROGRAM)"
done

echo "searching for assignments to IFS ..."
for PROGRAM in $PROGRAMS; do
    #  IFS assignment in ade_std_which() broke paa. So don't allow it.
    adetestsupport_invert_rc --quiet "egrep -wl 'IFS=' $(type -p $PROGRAM)"
done

echo "$PROGNAME: test completed"
