#!/bin/bash
#  $HeadURL: https://svn.pasta.freemyip.com/main/ade/tags/3.0.1/tests/bin/ADE512_stdlibs_ade_uuid.sh $ $LastChangedRevision: 10647 $

echo "defining functions ..."
devariant_uuid()
{
    sed 's/[0-9a-f]/x/g'
}

echo "format tests"
echo "shell"
adeshf "ade_create_uuid \"\$ERRSTACK_REF\" U; echo \"\$U\"; return \$ADE_OK" | devariant_uuid
echo "perl"
adeperlf "my(\$u); ADE::create_uuid(\$errstack_ref, \\\$u); print \"\$u\\n\"; return (\$ADE::OK);" | devariant_uuid
echo "python"
adepyf "import ade; (rc,u)=ade.create_uuid(errstack); print(u); return ade.ok" | devariant_uuid

echo "write/read tests"
UUID_FILE=/tmp/$$.uuid
echo "shell"
adeshf "ade_create_uuid \"\$ERRSTACK_REF\" U; ade_write_uuid \"\$ERRSTACK_REF\" $UUID_FILE \$U; ade_read_uuid \"\$ERRSTACK_REF\" $UUID_FILE U2; rm -f $UUID_FILE; if [ \$U = \$U2 ]; then echo same; else echo diff; fi; return \$ADE_OK" 
echo "perl"
adeperlf "my(\$u, \$u2); ADE::create_uuid(\$errstack_ref, \\\$u); ADE::write_uuid(\$errstack_ref, \"$UUID_FILE\", \$u); ADE::read_uuid(\$errstack_ref,\"$UUID_FILE\",\\\$u2); unlink(\"$UUID_FILE\"); if (\$u eq \$u2) { print \"same\\n\"; } else { print \"diff\\n\"; } return (\$ADE::OK);"
echo "python"
adepyf "import ade; import os; import sys; (rc,u)=ade.create_uuid(errstack); ade.write_uuid(errstack, \"$UUID_FILE\", u); (rc,u2)=ade.read_uuid(errstack,\"$UUID_FILE\"); os.unlink(\"$UUID_FILE\"); sys.stdout.write('same\\n' if u == u2 else 'diff\\n'); return ade.ok"

echo "all done"
