#!/bin/bash
#  $HeadURL: https://svn.pasta.freemyip.com/main/ade/tags/3.0.1/tests/bin/ADE600_adebun_makeclean_finds_adebun.sh $ $LastChangedRevision: 10403 $
PROGNAME=${0##*/}
SANDPIT=$(pwd)
. $(ade-config ade_share_prefix)/include/adetestsupport.sh

##############################################################################
#                           
#  Purpose of test: to verify that when adebun invokes 'make clean distclean'
# 		    that the first Makefile loaded by make can find aderoot,
#		    which it will want to do.
#
##############################################################################

##############################################################################
#                           
#  SETUP
#
##############################################################################

echo "creating base directories ..."
mkdir $SANDPIT/src $SANDPIT/src/doc $SANDPIT/pub $SANDPIT/seds

echo "creating a very basic makefile ..."
cat > $SANDPIT/src/Makefile <<'EOF'
clean distclean:
	echo "this is the '$@' recipe running"
	@$(MAKE) common

common:
	@echo "about to run 'which ade-config' ..."
	@which ade-config
EOF

echo "creating a ChangeLog ..."
cat > $SANDPIT/src/doc/ChangeLog <<EOF
Release 1.2.3 ($(date))
EOF

##############################################################################
#                           
#  TESTS START HERE
#
##############################################################################

adetestsupport_debug 10 "checking PATH *outside* adebun ..."
adetestsupport_debug 10 "PATH=$PATH"

echo "invoking adebun ..."
#  '$MAKE' is set by adetest. So this script can use it. It passes it to
#  adebun because adebun will call '$MAKE clean distclean' as part of making
#  the release.
CMD="adebun -v --author-name=\"Mr A. Author\" --author-email=\"aauthor@authors.net\" \
	--package-name=$PROGNAME -o $SANDPIT/pub/$PROGNAME-1.2.3 --make=$MAKE \
        $SANDPIT/src"
adetestsupport_debug 10 "calling '$CMD' ..."
eval "$CMD" > $SANDPIT/seds/adebun.sed
sed "s@$ADETEST_MODROOT@BLANKED_BY_$PROGNAME@" $SANDPIT/seds/adebun.sed
echo "all done"
